//
//  RSSIThresholdViewController.m
//  AsReaderScan
//
//  Created by Robin on 2018. 5. 8..
//

#import "RSSIThresholdViewController.h"
#import "Utils.h"
#import <AsReaderDockSDK/AsReaderDockSDK.h>

//#import <AreteUart/ComboRFIDApi.h>
@interface RSSIThresholdViewController ()<UITextFieldDelegate, AsReaderRFIDDeviceDelegate, AsReaderDeviceDelegate>

@property (weak, nonatomic) IBOutlet UITextField *olEditThreshold;

@end

@implementation RSSIThresholdViewController

#pragma mark - Lifecycle
//----------------------------------------------------------------
- (void)viewDidLoad
{
    [super viewDidLoad];
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:YES];
   
    AsReaderDevice *device = [AsReaderRFIDDevice sharedInstance];
    device.delegateDevice = self;
    device.delegateRFID = self;
    
    _olEditThreshold.delegate = self;
    [[AsReaderRFIDDevice sharedInstance] getRSSIThreshold];
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:YES];
    _olEditThreshold.delegate = nil;
    AsReaderDevice *device = [AsReaderRFIDDevice sharedInstance];
    device.delegateDevice = nil;
    device.delegateRFID = nil;
}

#pragma mark - Private method
//----------------------------------------------------------------
- (void)showAlert:(NSString*)strMsg
{
    [Utils showAlert:@"" message:strMsg view:self];
}

#pragma mark - IBAction
//----------------------------------------------------------------
- (IBAction)btnSetThreshold:(id)sender
{
    [_olEditThreshold resignFirstResponder];
    
    int nVal = [[_olEditThreshold text] intValue];
    if (![[AsReaderRFIDDevice sharedInstance] setRSSIThreshold:nVal]) {
        [self showAlert:@"FAIL"];
    }
}

#pragma mark - UITextField
//----------------------------------------------------------------
-(BOOL)textFieldShouldReturn:(UITextField *)textField
{
    [_olEditThreshold resignFirstResponder];
    return YES;
}

#pragma mark - AsReaderRFIDDeviceDelegate
//----------------------------------------------------------------
- (void)rssiThresholdReceived:(uint16_t)threshold
{
    [_olEditThreshold setText:[NSString stringWithFormat:@"%d",threshold]];
}

- (void)unknownCommandReceived:(int)commandCode
{
    if(commandCode == 0x00) {
        [self showAlert:@"Success"];
    } else {
         [self showAlert:@"FAIL"];
    }
}

- (void)plugged:(BOOL)plug
{
    
}

- (void)readerConnected:(int)status
{
    
}
@end
